<template>
    <div>
        <h1>Hi {{account.user.fullName}}!</h1>
        <div class="p-grid p-fluid" style="width: 500px; margin: auto">
            <div class="p-col-4"><label for="username">Username</label></div>
            <div class="p-col-8">
                <InputText id="username" v-model="account.user.username" autocomplete="off" :disabled="true"/>
            </div>
            <div class="p-col-4"><label for="email">Email</label></div>
            <div class="p-col-8">
                <InputText id="email" v-model="user.email" autocomplete="off"/>
            </div>

            <div class="p-col-4"><label for="fullName">Full name</label></div>
            <div class="p-col-8">
                <InputText id="fullName" v-model="user.fullName" autocomplete="off"/>
            </div>

            <div class="p-col-4"><label for="birthday">Birthday</label></div>
            <div class="p-col-8">
                <Calendar id="birthday" v-model="user.dob" dateFormat="dd/mm/yy"/>
            </div>
            <div class="p-col-6">
                <Button label="Update info" class="p-button-info" @click="doUpdateUser"/>
            </div>
            <div class="p-col-6">
                <Button label="Change password" class="p-button-info" @click="changePass"/>
            </div>
        </div>
        <p>
            <router-link to="/login">Logout</router-link>
        </p>
        <ChangePassDialog :dialogVisible="showDialog" @closeRequest ="closeDialog"/>
    </div>
</template>

<script>
    import {mapState, mapActions} from 'vuex'
    import ChangePassDialog from '../components/dialog/ChangePassDialog'
    export default {
        data() {
            return {
                date: null,
                showDialog: false
            }
        },
        components:{
            ChangePassDialog
        },
        computed: {
            ...mapState({
                account: state => state.account,
                msgUpdate: state => state.users.message,
                isOk: state => state.users.isOk,
                user: state => state.users.user
            })
        },
        created() {
            this.getUser();
        },
        watch: {
            msgUpdate: function () {
                this.$emit('showErrorEdit', this.msgUpdate);
            }
        },
        mounted() {
            this.$on('showErrorEdit', msg => {
                if (msg === '' || this.isOk === undefined)
                    return;
                if (this.isOk) {
                    this.$toast.add({severity: 'success', summary: 'Message', detail: msg, life: 3000});
                    this.account.user.fullName = this.user.fullName;
                    this.showDialog = false;
                } else {
                    const items = msg.split("|");
                    for (let i = 0; i < items.length; i++) {
                        this.$toast.add({severity: 'error', summary: 'Message Error', detail: items[i], life: 3000})
                    }
                }
                this.clearMessage();
            })
        },
        methods: {
            ...mapActions('users', {
                updateUser: 'updateUser',
                getUser: 'getUser',
                clearMessage: 'clearMessage'
            }),
            doUpdateUser() {
                this.updateUser(this.user)
            },
            changePass(){
              this.showDialog = true;
            },
            closeDialog() {
                this.showDialog = false;
            }
        }
    };
</script>
